//+------------------------------------------------------------------+
//|                                      PositionPropertiesPanel.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//---    
#include <Trade/Trade.mqh>
//---
#define INFOPANEL_SIZE 14 //     -
#define EXPERT_NAME MQL5InfoString(MQL5_PROGRAM_NAME) //  
//---  
bool                 pos_open=false;         //  /  
string               pos_symbol="";          // 
long                 pos_magic=0;            //  
string               pos_comment="";         // 
double               pos_swap=0.0;           // 
double               pos_commission=0.0;     // 
double               pos_price=0.0;          //  
double               pos_cprice=0.0;         //   
double               pos_profit=0.0;         // / 
double               pos_volume=0.0;         //  
double               pos_sl=0.0;             // Stop Loss 
double               pos_tp=0.0;             // Take Profit 
datetime             pos_time=NULL;          //   
long                 pos_id=0;               //  
ENUM_POSITION_TYPE   pos_type=WRONG_VALUE;   //  
//---   ,    
string pos_prop_names[INFOPANEL_SIZE]=
  {
   "name_pos_symbol",
   "name_pos_magic",
   "name_pos_comment",
   "name_pos_swap",
   "name_pos_commission",
   "name_pos_price",
   "name_pos_cprice",
   "name_pos_profit",
   "name_pos_volume",
   "name_pos_sl",
   "name_pos_tp",
   "name_pos_time",
   "name_pos_id",
   "name_pos_type"
  };
//---
//   ,    
string pos_prop_values[INFOPANEL_SIZE]=
  {
   "value_pos_symbol",
   "value_pos_magic",
   "value_pos_comment",
   "value_pos_swap",
   "value_pos_commission",
   "value_pos_price",
   "value_pos_cprice",
   "value_pos_profit",
   "value_pos_volume",
   "value_pos_sl",
   "value_pos_tp",
   "value_pos_time",
   "value_pos_id",
   "value_pos_type"
  };
//---    
string pos_prop_texts[INFOPANEL_SIZE]=
  {
   "Symbol :",
   "Magic Number :",
   "Comment :",
   "Swap :",
   "Commission :",
   "Open Price :",
   "Current Price :",
   "Profit :",
   "Volume :",
   "Stop Loss :",
   "Take Profit :",
   "Time :",
   "Identifier :",
   "Type :"
  };
//---   
double               close_price[]; // Close (  )
double               open_price[];  // Open (  )
//---  
CTrade trade;
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
bool CheckNewBar()
  {
//---      
   static datetime new_bar=NULL;
//---       
   static datetime time_last_bar[1]={0};
//---     
//        ,   
   if(CopyTime(_Symbol,Period(),0,1,time_last_bar)==-1)
     { Print(__FUNCTION__,":     : "+IntegerToString(GetLastError())+""); }
//---     
   if(new_bar==NULL)
     {
      //  
      new_bar=time_last_bar[0];
      Print(__FUNCTION__,":  ["+_Symbol+"][TF: "+TimeframeToString(Period())+"]["
            +TimeToString(time_last_bar[0],TIME_DATE|TIME_MINUTES|TIME_SECONDS)+"]");
      return(false); //  false   
     }
//---   
   if(new_bar!=time_last_bar[0])
     {
      new_bar=time_last_bar[0]; //     
      return(true); //     true
     }
//---     -    ,  false
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string TimeframeToString(ENUM_TIMEFRAMES timeframe)
  {
   string str="";
//---    ,    
   if(timeframe==WRONG_VALUE|| timeframe== NULL)
      timeframe= Period();
   switch(timeframe)
     {
      case PERIOD_M1  : str="M1";  break;
      case PERIOD_M2  : str="M2";  break;
      case PERIOD_M3  : str="M3";  break;
      case PERIOD_M4  : str="M4";  break;
      case PERIOD_M5  : str="M5";  break;
      case PERIOD_M6  : str="M6";  break;
      case PERIOD_M10 : str="M10"; break;
      case PERIOD_M12 : str="M12"; break;
      case PERIOD_M15 : str="M15"; break;
      case PERIOD_M20 : str="M20"; break;
      case PERIOD_M30 : str="M30"; break;
      case PERIOD_H1  : str="H1";  break;
      case PERIOD_H2  : str="H2";  break;
      case PERIOD_H3  : str="H3";  break;
      case PERIOD_H4  : str="H4";  break;
      case PERIOD_H6  : str="H6";  break;
      case PERIOD_H8  : str="H8";  break;
      case PERIOD_H12 : str="H12"; break;
      case PERIOD_D1  : str="D1";  break;
      case PERIOD_W1  : str="W1";  break;
      case PERIOD_MN1 : str="MN1"; break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
void GetBarsData()
  {
//---        
   int amount=2;
//---   ... 3 2 1 0
   ArraySetAsSeries(close_price,true);
   ArraySetAsSeries(open_price,true);
//---    
//       ,  ,    
   if(CopyClose(_Symbol,Period(),0,amount,close_price)<amount)
     {
      Print("    ("
            +_Symbol+", "+TimeframeToString(Period())+")    Close! "
            " "+IntegerToString(GetLastError())+": "+ErrorDescription(GetLastError()));
     }
//---    
//       ,  ,    
   if(CopyOpen(_Symbol,Period(),0,amount,open_price)<amount)
     {
      Print("    ("
            +_Symbol+", "+TimeframeToString(Period())+")    Open! "
            " "+IntegerToString(GetLastError())+": "+ErrorDescription(GetLastError()));
     }
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
int GetTradingSignal()
  {
//---    (0) :
   if(close_price[1]>open_price[1])
      return(0);
//---    (1) :
   if(close_price[1]<open_price[1])
      return(1);
//---   (3):
   return(3);
  }
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+
void TradingBlock()
  {
   int               signal=-1;           //    
   string            comment="hello :)";  //   
   double            start_lot=0.1;       //   
   double            lot=0.0;             //        
   double            ask=0.0;             //  ask
   double            bid=0.0;             //  bid
//---  
   signal=GetTradingSignal();
//--- ,   
   pos_open=PositionSelect(_Symbol);
//---    
   if(signal==0)
     {
      //---   Ask
      ask=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
      //---   
      if(!pos_open)
        {
         //---  
         //       ,    
         if(!trade.PositionOpen(_Symbol,ORDER_TYPE_BUY,lot,ask,0,0,comment))
           {
            Print("    BUY: ",GetLastError(),
                  " - ",ErrorDescription(GetLastError()));
           }
        }
      //---   
      else
        {
         //---   
         pos_type=(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);
         //---   SELL
         if(pos_type==POSITION_TYPE_SELL)
           {
            //---   
            pos_volume=PositionGetDouble(POSITION_VOLUME);
            //---  
            lot=NormalizeDouble(pos_volume+start_lot,2);
            //---  .    ,    
            if(!trade.PositionOpen(_Symbol,ORDER_TYPE_BUY,lot,ask,0,0,comment))
              {
               Print("    SELL: ",GetLastError(),
                     " - ",ErrorDescription(GetLastError()));
              }
           }
        }
      //---
      return;
     }
//---    
   if(signal==1)
     {
      //--   Bid
      bid=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
      //---   
      if(!pos_open)
        {
         //---  .    ,    
         if(!trade.PositionOpen(_Symbol,ORDER_TYPE_SELL,start_lot,bid,0,0,comment))
           { Print("    SELL: ",GetLastError()," - ",ErrorDescription(GetLastError())); }
        }
      //---   
      else
        {
         //---   
         pos_type=(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);
         //---   BUY
         if(pos_type==POSITION_TYPE_BUY)
           {
            //---   
            pos_volume=PositionGetDouble(POSITION_VOLUME);
            //---  
            lot=NormalizeDouble(pos_volume+start_lot,2);
            //---  .    ,    
            if(!trade.PositionOpen(_Symbol,ORDER_TYPE_SELL,lot,bid,0,0,comment))
              { Print("    SELL: ",GetLastError()," - ",ErrorDescription(GetLastError())); }
           }
        }
      //---
      return;
     }
  }
//+------------------------------------------------------------------+
//|   EDIT                                              |
//+------------------------------------------------------------------+
void CreateEdit(long             chart_id,         // id 
                int              sub_window,       //   ()
                string           name,             //  
                string           text,             //  
                ENUM_BASE_CORNER corner,           //  
                string           font_name,        // 
                int              font_size,        //  
                color            font_color,       //  
                int              x_size,           // 
                int              y_size,           // 
                int              x_distance,       //    X
                int              y_distance,       //    Y
                long             z_order,          // 
                color            background_color, //  
                bool             read_only)        //  "  "
  {
//    , ...
   if(ObjectCreate(chart_id,name,OBJ_EDIT,sub_window,0,0))
     {
      // ...  
      ObjectSetString(chart_id,name,OBJPROP_TEXT,text);                 //  
      ObjectSetInteger(chart_id,name,OBJPROP_CORNER,corner);            //   
      ObjectSetString(chart_id,name,OBJPROP_FONT,font_name);            //  
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,font_size);       //   
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,font_color);         //  
      ObjectSetInteger(chart_id,name,OBJPROP_BGCOLOR,background_color); //  
      ObjectSetInteger(chart_id,name,OBJPROP_XSIZE,x_size);             // 
      ObjectSetInteger(chart_id,name,OBJPROP_YSIZE,y_size);             // 
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,x_distance);     //   X
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,y_distance);     //   Y
      ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,false);         //   ,  FALSE
      ObjectSetInteger(chart_id,name,OBJPROP_ZORDER,z_order);           //  
      ObjectSetInteger(chart_id,name,OBJPROP_READONLY,read_only);       //   
      ObjectSetInteger(chart_id,name,OBJPROP_ALIGN,ALIGN_LEFT);         //    
      ObjectSetString(chart_id,name,OBJPROP_TOOLTIP,"\n");              //   ,  "\n"
     }
  }
//+------------------------------------------------------------------+
//|   LABEL                                             |
//+------------------------------------------------------------------+
void CreateLabel(long               chart_id,   // id 
                 int                sub_window, //   ()
                 string             name,       //  
                 string             text,       //  
                 ENUM_ANCHOR_POINT  anchor,     //  
                 ENUM_BASE_CORNER   corner,     //  
                 string             font_name,  // 
                 int                font_size,  //  
                 color              font_color, //  
                 int                x_distance, //    X
                 int                y_distance, //    Y
                 long               z_order)    // 
  {
//    , ...
   if(ObjectCreate(chart_id,name,OBJ_LABEL,sub_window,0,0))
     {
      // ...  
      ObjectSetString(chart_id,name,OBJPROP_TEXT,text);              //  
      ObjectSetString(chart_id,name,OBJPROP_FONT,font_name);         //  
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,font_color);      //   
      ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,anchor);         //   
      ObjectSetInteger(chart_id,name,OBJPROP_CORNER,corner);         //   
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,font_size);    //   
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,x_distance);  //   X
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,y_distance);  //   Y
      ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,false);      //   ,  FALSE
      ObjectSetInteger(chart_id,name,OBJPROP_ZORDER,z_order);        //  
      ObjectSetString(chart_id,name,OBJPROP_TOOLTIP,"\n");           //   ,  "\n"
     }
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void DeleteObjectByName(string name)
  {
   int  sub_window=0;      //   ,    
   bool res       =false;  //     
//---    
   sub_window=ObjectFind(ChartID(),name);
//---
   if(sub_window>=0) //  ,..
     {
      res=ObjectDelete(ChartID(),name); // ... 
      //---
      //     ,   
      if(!res)
         Print("   : ("+IntegerToString(GetLastError())+"): "+ErrorDescription(GetLastError()));
     }
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void ZeroPositionProperties()
  {
   pos_symbol     ="";
   pos_comment    ="";
   pos_magic      =0;
   pos_price      =0.0;
   pos_cprice     =0.0;
   pos_sl         =0.0;
   pos_tp         =0.0;
   pos_type       =WRONG_VALUE;
   pos_volume     =0.0;
   pos_commission =0.0;
   pos_swap       =0.0;
   pos_profit     =0.0;
   pos_time       =NULL;
   pos_id         =0;
  }
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
string PositionTypeToString(ENUM_POSITION_TYPE type)
  {
   string str="";
//---
   if(type==POSITION_TYPE_BUY)
      str="buy";
   else if(type==POSITION_TYPE_SELL)
      str="sell";
   else
      str="wrong value";
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void GetPositionProperties()
  {
// ,   
   pos_open=PositionSelect(_Symbol);
//---
   if(pos_open) //   ,   
     {
      pos_symbol     =PositionGetString(POSITION_SYMBOL);
      pos_comment    =PositionGetString(POSITION_COMMENT);
      pos_magic      =PositionGetInteger(POSITION_MAGIC);
      pos_price      =PositionGetDouble(POSITION_PRICE_OPEN);
      pos_cprice     =PositionGetDouble(POSITION_PRICE_CURRENT);
      pos_sl         =PositionGetDouble(POSITION_SL);
      pos_tp         =PositionGetDouble(POSITION_TP);
      pos_type       =(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);
      pos_volume     =PositionGetDouble(POSITION_VOLUME);
      pos_commission =PositionGetDouble(POSITION_COMMISSION);
      pos_swap       =PositionGetDouble(POSITION_SWAP);
      pos_profit     =PositionGetDouble(POSITION_PROFIT);
      pos_time       =(datetime)PositionGetInteger(POSITION_TIME);
      pos_id         =PositionGetInteger(POSITION_IDENTIFIER);
     }
   else //   ,    
   ZeroPositionProperties();
//---
   SetInfoPanel(); // /  
  }
//+------------------------------------------------------------------+
//|                                 |
//|------------------------------------------------------------------+
void SetInfoPanel()
  {
   int               y_bg=18;             //    Y    
   int               y_property=32;       //    Y      
   int               line_height=12;      //  
//---
   int               font_size=8;         //  
   string            font_name="Calibri"; // 
   color             font_color=clrWhite; //  
//---
   ENUM_ANCHOR_POINT anchor=ANCHOR_RIGHT_UPPER; //      
   ENUM_BASE_CORNER  corner=CORNER_RIGHT_UPPER; //       
//---    X
   int               x_first_column=120;  //   ( )
   int               x_second_column=10;  //   ( )
//---    
   if(MQL5InfoInteger(MQL5_VISUAL_MODE))
     {
      y_bg=2;
      y_property=16;
     }
//---      Y       
   int               y_prop_array[INFOPANEL_SIZE]={0};
//---         
   for(int i=0; i<INFOPANEL_SIZE; i++)
     {
      if(i==0) y_prop_array[i]=y_property;
      else     y_prop_array[i]=y_property+line_height*i;
     }
//---  -
   CreateEdit(0,0,"InfoPanelBackground","",corner,font_name,8,clrWhite,230,190,231,y_bg,0,C'15,15,15',true);
//---  -
   CreateEdit(0,0,"InfoPanelHeader","  POSITION  PROPERTIES",corner,font_name,8,clrWhite,230,14,231,y_bg,1,clrFireBrick,true);
//---       
   for(int i=0; i<INFOPANEL_SIZE; i++)
     {
      //---  
      CreateLabel(0,0,pos_prop_names[i],pos_prop_texts[i],anchor,corner,font_name,font_size,font_color,x_first_column,y_prop_array[i],2);
      //---  
      CreateLabel(0,0,pos_prop_values[i],GetPropertyValue(i),anchor,corner,font_name,font_size,font_color,x_second_column,y_prop_array[i],2);
     }
//---
   ChartRedraw(); //  
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void DeleteInfoPanel()
  {
   DeleteObjectByName("InfoPanelBackground");   //   
   DeleteObjectByName("InfoPanelHeader");       //   
//---      
   for(int i=0; i<INFOPANEL_SIZE; i++)
     {
      DeleteObjectByName(pos_prop_names[i]);    //  
      DeleteObjectByName(pos_prop_values[i]);   //  
     }
//---
   ChartRedraw(); //  
  }
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
string GetPropertyValue(int number)
  {
//---         
//    ,  , Stop Loss  Take Profit
   string empty="-";
//---   ,    
   if(pos_open)
     {
      switch(number)
        {
         case 0  : return(pos_symbol);                                           break;
         case 1  : return(IntegerToString((int)pos_magic));                      break;
         //---   ,  ,  -  
         case 2  : return(pos_comment!="" ? pos_comment : empty);                break;
         case 3  : return(DoubleToString(pos_swap,2));                           break;
         case 4  : return(DoubleToString(pos_commission,2));                     break;
         case 5  : return(DoubleToString(pos_price,_Digits));                    break;
         case 6  : return(DoubleToString(pos_cprice,_Digits));                   break;
         case 7  : return(DoubleToString(pos_profit,2));                         break;
         case 8  : return(DoubleToString(pos_volume,2));                         break;
         case 9  : return(pos_sl!=0.0 ? DoubleToString(pos_sl,_Digits) : empty); break;
         case 10 : return(pos_tp!=0.0 ? DoubleToString(pos_tp,_Digits) : empty); break;
         case 11 : return(TimeToString(pos_time,TIME_DATE|TIME_MINUTES));        break;
         case 12 : return(IntegerToString((int)pos_id));                         break;
         case 13 : return(PositionTypeToString(pos_type));                       break;

         default : return(empty);
        }
     }
//---
//    ,     "-"
   return(empty);
  }
//+------------------------------------------------------------------+
//|                 |
//+------------------------------------------------------------------+
string GetDeinitReasonText(int reason_code)
  {
   string text="";
//---
   switch(reason_code)
     {
      case REASON_PROGRAM :     // 0
         text="   ,   ExpertRemove().";      break;
      case REASON_REMOVE :      // 1
         text=" '"+EXPERT_NAME+"'    .";                break;
      case REASON_RECOMPILE :   // 2
         text=" '"+EXPERT_NAME+"'  .";                break;
      case REASON_CHARTCHANGE : // 3
         text="     .";                             break;
      case REASON_CHARTCLOSE :  // 4
         text=" .";                                                     break;
      case REASON_PARAMETERS :  // 5
         text="    .";                     break;
      case REASON_ACCOUNT :     // 6
         text="  .";                                           break;
      case REASON_TEMPLATE :    // 7
         text="   .";                                    break;
      case REASON_INITFAILED :  // 8
         text=" ,   OnInit()   .";   break;
      case REASON_CLOSE :       // 9
         text="  .";                                               break;
      default : text="  .";
     }
//---
   return text;
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
string ErrorDescription(int error_code)
  {
   string error_string="";
//---
   switch(error_code)
     {
      //---    

      case 10004: error_string="";                                                         break;
      case 10006: error_string=" ";                                                break;
      case 10007: error_string="  ";                                        break;
      case 10008: error_string=" ";                                                  break;
      case 10009: error_string=" ";                                                break;
      case 10010: error_string="  ";                                       break;
      case 10011: error_string="  ";                                        break;
      case 10012: error_string="    ";                             break;
      case 10013: error_string=" ";                                             break;
      case 10014: error_string="   ";                                    break;
      case 10015: error_string="   ";                                     break;
      case 10016: error_string="   ";                                    break;
      case 10017: error_string=" ";                                              break;
      case 10018: error_string=" ";                                                    break;
      case 10019: error_string="   ";                                break;
      case 10020: error_string=" ";                                                 break;
      case 10021: error_string="    ";                     break;
      case 10022: error_string="     ";                        break;
      case 10023: error_string="  ";                                     break;
      case 10024: error_string="  ";                                          break;
      case 10025: error_string="   ";                                         break;
      case 10026: error_string="  ";                                 break;
      case 10027: error_string="   ";                     break;
      case 10028: error_string="   ";                               break;
      case 10029: error_string="   ";                                    break;
      case 10030: error_string="      ";        break;
      case 10031: error_string="    ";                              break;
      case 10032: error_string="     ";                   break;
      case 10033: error_string="     ";                break;
      case 10034: error_string="         ";  break;

      //---   

      case 0:  //   
      case 4001: error_string="  ";                                                                                                   break;
      case 4002: error_string="       ";                                                          break;
      case 4003: error_string="     ";                                                                                 break;
      case 4004: error_string="     ";                                                                            break;
      case 4005: error_string="    /   /     / ";                    break;
      case 4006: error_string="  ,       ";                                   break;
      case 4007: error_string="          ";                           break;
      case 4008: error_string="    ";                                                                                break;
      case 4009: error_string=" ";                                                                                                     break;
      case 4010: error_string="   / ";                                                                                        break;
      case 4011: error_string="    2 ";                                                                              break;
      case 4012: error_string=" ";                                                                                                             break;
      case 4013: error_string="  ";                                                                                                         break;
      case 4014: error_string="     ";                                                                                       break;
      //-- 
      case 4101: error_string="  ";                                                                                                 break;
      case 4102: error_string="  ";                                                                                                              break;
      case 4103: error_string="  ";                                                                                                                break;
      case 4104: error_string="   ,     ";                                                                       break;
      case 4105: error_string="  ";                                                                                                         break;
      case 4106: error_string="       ";                                                                              break;
      case 4107: error_string="   ";                                                                                                  break;
      case 4108: error_string="   ";                                                                                                     break;
      case 4109: error_string="   ";                                                                                        break;
      case 4110: error_string="   ";                                                                                                   break;
      case 4111: error_string="   ";                                                                                                     break;
      case 4112: error_string="   ";                                                                                                   break;
      case 4113: error_string=",   ,  ";                                                                             break;
      case 4114: error_string="     ";                                                                                      break;
      case 4115: error_string="     ";                                                                                        break;
      case 4116: error_string="     ";                                                                                        break;
      //--  
      case 4201: error_string="     ";                                                                                        break;
      case 4202: error_string="   ";                                                                                                    break;
      case 4203: error_string="    ";                                                                           break;
      case 4204: error_string="  ,  ";                                                                              break;
      case 4205: error_string="  ,  ";                                                                              break;
      //-- MarketInfo
      case 4301: error_string=" ";                                                                                                              break;
      case 4302: error_string="    MarketWatch";                                                                                                  break;
      case 4303: error_string="   ";                                                                                        break;
      case 4304: error_string="    (  )";                                                                                break;
      //--   
      case 4401: error_string="   !";                                                                                               break;
      case 4402: error_string="   ";                                                                                        break;
      //-- Global_Variables
      case 4501: error_string="     ";                                                                          break;
      case 4502: error_string="        ";                                                       break;
      case 4510: error_string="   ";                                                                                                     break;
      case 4511: error_string="   ";                                                                                                   break;
      case 4512: error_string="   ";                                                                                      break;
      case 4513: error_string="   ";                                                                                      break;
      case 4514: error_string="     ftp";                                                                                                break;
      //--   
      case 4601: error_string="     ";                                                                      break;
      case 4602: error_string="    ";                                                                                    break;
      //--   
      case 4603: error_string="    ";                                                                   break;
      //-- Account
      case 4701: error_string="   ";                                                                                          break;
      case 4751: error_string="   ";                                                                                       break;
      case 4752: error_string="   ";                                                                                                 break;
      case 4753: error_string="  ";                                                                                                              break;
      case 4754: error_string="  ";                                                                                                                 break;
      case 4755: error_string="  ";                                                                                                               break;
      case 4756: error_string="    ";                                                                                            break;
      //-- 
      case 4801: error_string=" ";                                                                                                              break;
      case 4802: error_string="    ";                                                                                                  break;
      case 4803: error_string="    ";                                                                                   break;
      case 4804: error_string="       ";                                                                           break;
      case 4805: error_string="   ";                                                                                                break;
      case 4806: error_string="   ";                                                                                                   break;
      case 4807: error_string="  ";                                                                                                      break;
      case 4808: error_string="     ";                                                                      break;
      case 4809: error_string="    ";                                                                                   break;
      case 4810: error_string="        ";                                                        break;
      case 4811: error_string="       ";                                                                    break;
      case 4812: error_string="    ";                                                                            break;
      //--  
      case 4901: error_string="     ";                                                                                               break;
      case 4902: error_string="     ";                                                                                                 break;
      case 4903: error_string="      ";                                                                                       break;
      case 4904: error_string="        ";                                                                       break;
      //--  
      case 5001: error_string="      64 ";                                                                              break;
      case 5002: error_string="  ";                                                                                                          break;
      case 5003: error_string="   ";                                                                                                       break;
      case 5004: error_string="  ";                                                                                                           break;
      case 5005: error_string="    ";                                                                                             break;
      case 5006: error_string="  ";                                                                                                           break;
      case 5007: error_string="      ,    ";                                                                  break;
      case 5008: error_string="  ";                                                                                                           break;
      case 5009: error_string="     ";                                                                                              break;
      case 5010: error_string="     ";                                                                                              break;
      case 5011: error_string="     ";                                                                                            break;
      case 5012: error_string="     ";                                                                                           break;
      case 5013: error_string="       CSV";                                                                                   break;
      case 5014: error_string="     CSV";                                                                                                 break;
      case 5015: error_string="  ";                                                                                                             break;
      case 5016: error_string="    ,      ";                                                              break;
      case 5017: error_string="      ,    ";                                                     break;
      case 5018: error_string="  ,  ";                                                                                                       break;
      case 5019: error_string="  ";                                                                                                              break;
      case 5020: error_string="    ";                                                                                                    break;
      case 5021: error_string="  ";                                                                                                        break;
      case 5022: error_string="  ";                                                                                                        break;
      case 5023: error_string=" ,   ";                                                                                                       break;
      case 5024: error_string="    ";                                                                                                break;
      case 5025: error_string="    (,          )";               break;
      //--  
      case 5030: error_string="   ";                                                                                                               break;
      case 5031: error_string="   ";                                                                                                         break;
      case 5032: error_string="   ";                                                                                                        break;
      case 5033: error_string="    ";                                                                                             break;
      case 5034: error_string="   ";                                                                                                  break;
      case 5035: error_string="  ,  ";                                                                                              break;
      case 5036: error_string="  , ,  ULONG_MAX";                                                                                    break;
      case 5037: error_string="  ";                                                                                                      break;
      case 5038: error_string="  ,  ";                                                                                 break;
      case 5039: error_string=" ,   ";                                                                                 break;
      case 5040: error_string="   string";                                                                                                break;
      case 5041: error_string="   ";                                                                                                     break;
      case 5042: error_string="    0,  ";                                                                                 break;
      case 5043: error_string="      ";                                                                                 break;
      case 5044: error_string="  ";                                                                                                       break;
      //--   
      case 5050: error_string="  .        ,      ";   break;
      case 5051: error_string="    AS_SERIES,    ";                                                             break;
      case 5052: error_string="  ,     ";                                                                break;
      case 5053: error_string="  ";                                                                                                            break;
      case 5054: error_string="   ";                                                                                                     break;
      case 5055: error_string="   ";                                                                                                   break;
      case 5056: error_string="    ";                                                                                            break;
      case 5057: error_string="    double";                                                                                                  break;
      case 5058: error_string="    float";                                                                                                   break;
      case 5059: error_string="    long";                                                                                                    break;
      case 5060: error_string="    int";                                                                                                     break;
      case 5061: error_string="    short";                                                                                                   break;
      case 5062: error_string="    char";                                                                                                    break;
      //--  

      default: error_string="  ";
     }
//---
   return(error_string);
  }
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   
   CheckNewBar();
//---        
   GetPositionProperties();
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---     
   Print(GetDeinitReasonText(reason));
//---    
   if(reason==REASON_REMOVE)
      //---     ,     
      DeleteInfoPanel();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---    , 
   if(!CheckNewBar())
      return;
//---    
   else
     {
      GetBarsData();  //   
      TradingBlock(); //    
     }
//---       
   GetPositionProperties();
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---        
   GetPositionProperties();
  }
//+------------------------------------------------------------------+
